program tictac;
{ 1. spielbare Version, 2 Spieler, Gadgetvorbreitung : 29.12.94 }
{ Spieler durch Computer ersetzbar, Ende-Routine     : 01.01.95 }

uses crt,dos,graph,intuit,drivers;

const titel ='* * *   U J a '' s   T i c T a c T o e   *  V 0.99  *  TP6  *  01.01.95  *';
      imafil='TicTac.ima';
      dx=108; dy=96; dzx=32; dzy=16; ox=-96; oy=512;

type  feld =array[1..4,1..4,1..4] of integer;
      kkord=array[1..4,1..3] of integer;

var ok,ende,aus,bw:boolean;
    ima           :array[1..5] of Image;
    igad          :array[1..6] of Gadget;
    ibord1,ibord2 :Border;
    xy1,xy2       :Koords;
    itext1,itext2 :array[1..8] of IntuiText;
    i,mx,my,dran  :integer;

    f             :feld;
    blinker       :kkord;
    anz,nr,c1,c2,j,k,x,y,z:integer;

{$i tictac1.inc }
{$i tictac2.inc }

procedure message(dran:integer; temp:string);
var t1:string; c:integer;
begin
   if (dran=1) or (dran=2) then begin
      str(dran:2,t1);
      if dran=1 then c:=3 else c:=9;
      if igad[dran].onoff then t1:='Compi'+t1+' '+temp
      else t1:='Spieler'+t1+' '+temp;
   end else begin
      c:=15;
      t1:=temp;
   end;
   rectfill(12,460,255,468,c);
   setcolor(15);
   outtextxy(17,460,t1);
   setcolor(0);
   outtextxy(16,460,t1);
end;

procedure initfeld(var f:feld; var b:kkord);
var i,j,k:integer;
begin
for i:=1 to 4 do for j:=1 to 4 do for k:=1 to 4 do f[i,j,k]:=0;
for i:=1 to 4 do for j:=1 to 3 do b[i,j]:=0;
end;

procedure enderoutine(var dran,anz:integer; blinker:kkord; var ende:boolean);
var i,j,mx,my:integer;
    stopp:boolean;
begin
if dran=1 then dran:=2 else if dran=2 then dran:=1;
stopp:=dran>0;
while stopp and (not ende) do begin
   showmouse;
   case dran of
  1,2:begin
         hidemouse;
         message(dran,' hat gewonnen!');
         for i:=1 to anz do zeichnechip(3,blinker[i,1],blinker[i,2],blinker[i,3]);
         showmouse;
         delay(200);
         hidemouse;
         for i:=1 to anz do zeichnechip(dran,blinker[i,1],blinker[i,2],blinker[i,3]);
         showmouse;
         delay(500);
      end;
   3: begin { unentschieden }
         message(dran,'alle Pltze besetzt!');
      end;
   end;

   j:=0;
   getgadget(addr(igad[1]),j,mx,my);
   if keypressed then ende:=readkey=#27;
   hidemouse;
   stopp:=(j<1) or (j>6);
   case j of
   1,2,3: begin
          igad[j].onoff:=not igad[j].onoff;
          Drawgadget(addr(igad[j]));
          if j=3 then begin
             anz:=3;
             if igad[j].onoff then inc(anz);
          end;
        end;
   5: ende:=true;
   end;

end; {while}
end;




{ ---------------------------------------------------------------- }

begin
   anz:=4;
   bw:=false;
   if paramcount>1 then if paramstr(1)='3' then anz:=3;
   bw:=(paramstr(paramcount)='B') or (paramstr(paramcount)='b');

   initscreen(ok);
   if ok then begin
      imagesholen;
      screenfarben(bw);
      initstructures;
      igad[3].onoff:=anz=4;
   end;

   ende:=false;
   while not ende do begin
      initfeld(f,blinker);
      zeichnescreen(anz);
      dran:=1;
      aus:=false;
      message(dran,'... am Zuge');
      while (not (ende or aus)) and (dran<3) and (dran<>0) do begin
         showmouse;
         delay(50);
         getgadget(addr(igad[1]),i,mx,my);
         hidemouse;
         if keypressed then ende:=readkey=#27;
         case i of
         1,2,3: begin
                igad[i].onoff:=not igad[i].onoff;
                Drawgadget(addr(igad[i]));
                if i=3 then begin
                   dran:=0;
                   anz:=3;
                   if igad[i].onoff then inc(anz);
                end else message(dran,'... am Zuge');
              end;
         4: dran:=0;
         5: ende:=true;
         6: if not igad[dran].onoff then begin
               spielermove(dran,anz,mx,my,aus,f,blinker);
               if not aus then message(dran,' ist am Zuge');
            end;
         end;
         if not aus then if (dran=1) or (dran=2)
                    then if igad[dran].onoff then begin
            compimove(dran,anz,f,blinker,aus);
            if not aus then message(dran,' ist am Zuge');
         end;
      end;
      if aus or (dran=3) or (dran=0) then enderoutine(dran,anz,blinker,ende);
   end;


textmode(3);
end.
