{ --- TicTac1.INC, Erstellen der Gadgets und Images, Screenzeichnen ------ }
{ procedure imagesholen;    }
{ procedure screenfarben;   }
{ procedure initstructures; }
{ procedure zeichnescreen;  }
{ ------------------------------------------------------------------------ }

procedure imagesholen;
var i        :integer;
    f        :file;
    size,anz :word;
begin
assign(f,imafil);
reset(f,1);
for i:=1 to 5 do begin
   BlockRead(f,ima[i],sizeof(Image),anz);
   with ima[i] do begin
      size:=imagesize(1,1,width,height);
      GetMem(p_data,size);
      BlockRead(f,p_data^,size,anz);
   end;
end;
close(f);
end;

{ --- }

procedure screenfarben(bw:boolean);
const pal : array[0..15,0..2] of word
          = (( 0, 0, 0),( 0,19,28),( 5,24,36),(15,31,45),
             (28,39,54),(44,51,63),(42, 0,20),(47, 6,21),
             (52,15,24),(57,25,29),(63,38,38),(52,31,27),
             (54,37,30),(57,44,36),(59,49,40),(62,56,47));
      bwp : array[0..15,0..2] of word
          = (( 0, 0, 0),(28,28,28),(24,24,24),(36,36,36),
             (48,48,48),(62,62,62),(03,03,03),(10,10,10),
             (16,16,16),(24,24,24),(32,32,32),(36,36,36),
             (40,40,40),(46,46,46),(49,49,49),(55,55,55));
var i:integer;
begin
   for i:=0 to 15 do SetPalette(i,i);
   if bw then for i:=0 to 15 do SetRGBPalette(i,bwp[i,0],bwp[i,1],bwp[i,2])
   else for i:=0 to 15 do SetRGBPalette(i,pal[i,0],pal[i,1],pal[i,2]);
end;

{ ------------ }

procedure zeichnechip(nr,x,y,z:integer);
var i,xx,yy:integer;
begin
   case nr of
   0: i:=2;
   1: i:=5;
   2: i:=4;
   else i:=3;
   end;
   xx:=ox+x*dx+z*dzx;
   yy:=oy-y*dy-z*dzy;
   PutImage(xx,yy,ima[1].p_data^,andput);
   PutImage(xx,yy,ima[i].p_data^,orput);
end;

{ ------------------ }

procedure initstructures;
var i,j,k:integer;
begin
   i:=72;
   j:=16;
   xy1[0]:=0; xy1[1]:=j-2; xy1[2]:=0;   xy1[3]:=0;   xy1[4]:=i-1; xy1[5]:=0;
   xy2[0]:=0; xy2[1]:=j-1; xy2[2]:=i-1; xy2[3]:=j-1; xy2[4]:=i-1; xy2[5]:=1;

   with ibord1 do begin
         x:=0;
         y:=0;
         fpen:=15;
         bpen:=3;
         ecken:=3;
         p_ecken:=addr(xy1);
         p_nextborder:=addr(ibord2);
      end;
      with ibord2 do begin
         x:=0;
         y:=0;
         fpen:=0;
         bpen:=3;
         ecken:=3;
         p_ecken:=addr(xy2);
         p_nextborder:=nil;
   end;

   itext1[1].itext:='Spieler1';
   itext1[2].itext:='Spieler2';
   itext1[3].itext:='3/Zeile ';
   itext1[4].itext:=' Neu    ';
   itext1[5].itext:=' Quit   ';
   itext1[6].itext:=' Compi1 ';
   itext1[7].itext:=' Compi2 ';
   itext1[8].itext:='4/Zeile ';


   for i:=1 to 8 do begin
      with itext1[i] do begin
         x:=5;
         y:=4;
         bpen:=13;
         fpen:=15;
         drmode:=jam2;
         p_nexttext:=addr(itext2[i])
      end;
      itext2[i]:=itext1[i];
      with itext2[i] do begin
         x:=4;
         fpen:=0;
         p_nexttext:=nil
      end;
   end;

   for i:=1 to 6 do with igad[i] do begin
      id:=i;
      gadgettyp:=boolgadget;
      active:=true;
      onoff:=false;
      if i<6 then begin
         x:=182+i*74;
         y:=456;
         width:=72;
         height:=16;
         bpen:=13;
         p_loborder:=addr(ibord1);
         p_lointuitext:=addr(itext1[i]);
         if i>3 then p_hiintuitext:=nil else p_hiintuitext:=addr(itext1[i+5]);
      end else begin
         bpen:=1;
         p_lointuitext:=nil;
         p_hiintuitext:=nil;
         p_loborder:=nil;
         p_hiborder:=p_loborder;
         width :=3*(dx+dzx)+ima[1].width;
         height:=3*(dy+dzy)+ima[1].height;
         x:=ox+dx+dzx;
         y:=oy-(height+dy+dzy)+ima[1].height;
      end;

      p_loimage:=nil;
      hibpen:=-1;
      p_hiborder:=p_loborder;
      p_hiimage:=p_loimage;
      if i<6 then p_nextgadget:=addr(igad[i+1]) else p_nextgadget:=nil;
   end;

end;

{ --- }

procedure zeichnescreen(anz:integer);
var i,j,k,x,y,z:integer;
begin
{ Boxen: }
rectfill(0,0,639,479,2);
rectfill(12,12,627,27,0);
rectfill(12,460,627,475,0);
rectfill(8,8,623,23,13);
rectfill(8,456,623,471,13);
setcolor(15);
line(8,8,623,8);      line(8,8,8,22);
line(8,456,623,456);  line(8,456,8,470);

i:=20;
j:=12;
setcolor(15);
outtextxy(i+1,j,titel);
setcolor(0);
outtextxy(i,j,titel);

RefreshGadgets(addr(igad[1]));

for k:=anz downto 1 do begin
   for i:=1 to anz do begin
      x:=ox+dx+k*dzx+ima[1].width div 2;
      y:=oy-(i*dy+k*dzy)+ima[1].height div 2;
      setcolor(2);
      line(x,y,x+pred(anz)*dx,y);
      setcolor(3);
      line(x,y-1,x+pred(anz)*dx,y-1);
      setcolor(0);
      line(x,y+1,x+pred(anz)*dx,y+1);

      x:=ox+k*dzx+i*dx+ima[1].width div 2;
      y:=oy-k*dzy-dy+ima[1].height div 2;
      setcolor(3);
      line(x,y,x,y-pred(anz)*dy);
      setcolor(0);
      line(x+1,y,x+1,y-pred(anz)*dy);
      setcolor(2);
      line(x-1,y,x-1,y-pred(anz)*dy);

      x:=ox+dzx+i*dx+ima[1].width div 2;
      y:=oy-dzy-k*dy+ima[1].height div 2;
      setcolor(2);
      line(x,y,x+pred(anz)*dzx,y-pred(anz)*dzy);
      setcolor(3);
      line(x-1,y-1,x+pred(anz)*dzx-1,y-pred(anz)*dzy-1);
      setcolor(0);
      line(x+1,y+1,x+pred(anz)*dzx+1,y-pred(anz)*dzy+1);


   end;
end;

for i:=1 to anz do for j:=1 to anz do for k:=1 to anz do zeichnechip(0,i,j,k);




end;

{ ----------------------------------------------------------------------- }
